/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH & Co. KG                *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.32                          *
*        Compiled Oct  8 2015, 11:59:02                              *
*        (c) 2015 Segger Microcontroller GmbH & Co. KG               *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

// USER START (Optionally insert additional includes)
#include "string.h"
// USER END

#include "DIALOG.h"

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0 (GUI_ID_USER + 0x00)
#define ID_TREEVIEW_0 (GUI_ID_USER + 0x01)


// USER START (Optionally insert additional defines)
// USER END

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/

// USER START (Optionally insert additional static data)
extern GUI_CONST_STORAGE GUI_BITMAP bmImg_plus;
extern GUI_CONST_STORAGE GUI_BITMAP bmImg_minus;

TREEVIEW_Handle hTreeview;
TREEVIEW_ITEM_Handle phItem[100];
// USER END

/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "Window_CustomTreeview", ID_WINDOW_0, 0, 0, 320, 240, 0, 0x0, 0 },
  { TREEVIEW_CreateIndirect, "Treeview", ID_TREEVIEW_0, 60, 20, 200, 200, 0, 0x0, 1 },
  // USER START (Optionally insert additional widgets)
  // USER END
};

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/

// USER START (Optionally insert additional static code)
// Callback function for TREEVIEW widget
static void _cbTreeview(WM_MESSAGE * pMsg) {
	switch (pMsg->MsgId) {
	case WM_KEY:
		// Default keyboard handling
		TREEVIEW_Callback(pMsg);		
		
		// Invalidate widget to avoid artifacts when redrawing selection
		WM_Invalidate(pMsg->hWin);
		break;
	default:
		TREEVIEW_Callback(pMsg);
		break;
	}
}

// Custom drawing function for the TREEVIEW widget
static int _OwnerDraw_TREEVIEW(const WIDGET_ITEM_DRAW_INFO * pDrawItemInfo) {
	U8 pBuffer[100], pBufferInfo[100];
	U8 Index;
	GUI_RECT pRect;

	TREEVIEW_ITEM_INFO pInfoCur, pInfoNext;
	
	// UserData: 0 - item not selected
	//			 1 - item selected
	//			 2 - do nothing, just pass it to image handling subroutine
	//			 3 - previous item was selected so correct item index calculation for new coords
	U8 UserData;

	switch (pDrawItemInfo->Cmd) {
	case WIDGET_ITEM_GET_YSIZE:	// get size subroutine
		TREEVIEW_GetUserData(pDrawItemInfo->hWin, &UserData, 1);

		// If item is selected increase height by 32 to add info text
		if (UserData == 1)
			return TREEVIEW_OwnerDraw(pDrawItemInfo) + 32; // return height = 64
		else
			return TREEVIEW_OwnerDraw(pDrawItemInfo); // else return default height = 32
		break;
	case WIDGET_ITEM_DRAW_TEXT:	// Text drawing subroutine
		// Calc the Index to get the item handler from the list. Divide y0 by the item height.
		Index = pDrawItemInfo->y0 / 32;

		TREEVIEW_GetUserData(pDrawItemInfo->hWin, &UserData, 1);

		switch (UserData) {
		case 1:
			// if item was selected change UserData to 2 and pass it to bitmap drawing subroutine
			UserData = 2;
			TREEVIEW_SetUserData(pDrawItemInfo->hWin, &UserData, 1);
			break;
		case 3:
			// Previous item was selected so correct item index calculation for new coords
			Index = (pDrawItemInfo->y0 - 32) / 32;
			break;
		}

		// Make sure to clear item rect
		GUI_SetBkColor(GUI_WHITE);
		GUI_Clear();

		// Set the font
		GUI_SetFont(GUI_FONT_32_ASCII);
	
		// Get item text and info in the treeview
		TREEVIEW_ITEM_GetText(phItem[Index], pBuffer, 100);
		TREEVIEW_ITEM_GetInfo(phItem[Index], &pInfoCur);

		// Set the rect for blue background and frame
		pRect.x0 = pDrawItemInfo->x0 + pInfoCur.Level * 15 + 15;
		pRect.y0 = pDrawItemInfo->y0;
		pRect.x1 = pRect.x0 + 150;
		pRect.y1 = pDrawItemInfo->y1 - 32;

		if (pInfoCur.IsNode == 0)	// If item is leaf
		{
			if (TREEVIEW_GetSel(pDrawItemInfo->hWin) == phItem[Index])	// and selected
			{
				// Draw framed blue background rect 
				GUI_SetColor(GUI_BLACK);
				GUI_DrawRectEx(&pRect);
				GUI_SetColor(GUI_BLUE);
				GUI_FillRect(pRect.x0 + 1, pRect.y0 + 1, pRect.x1 - 1, pRect.y1 - 1);
				
				// Set new rect for lightblue backround and frame
				pRect.y0 += 31;
				pRect.y1 += 32;
				
				// Draw it
				GUI_SetColor(GUI_BLACK);
				GUI_DrawRectEx(&pRect);
				GUI_SetColor(GUI_LIGHTBLUE);
				GUI_FillRect(pRect.x0 + 1, pRect.y0 + 1, pRect.x1 - 1, pRect.y1 - 1);

				// Make info string
				strcpy(pBufferInfo, pBuffer);
				strcat(pBufferInfo, " Info");

				// Draw the info text in lower rect
				GUI_SetColor(GUI_BLACK);
				GUI_SetTextMode(GUI_TM_TRANS);
				GUI_DispStringAt(pBufferInfo, pDrawItemInfo->x0 + 20 + pInfoCur.Level * 15, pDrawItemInfo->y0 + 32);
			}
		}

		// If next item selected and it is leaf change UserData to 1 to handle it in get size subroutine
		if (TREEVIEW_GetSel(pDrawItemInfo->hWin) == phItem[Index + 1]) {
			TREEVIEW_ITEM_GetInfo(phItem[Index + 1], &pInfoNext);

			// Change UserData for leafs only
			if (pInfoNext.IsNode == 0)
			{
				UserData = 1;
				TREEVIEW_SetUserData(pDrawItemInfo->hWin, &UserData, 1);
			}
		}

		// Draw the item text in upper rect
		GUI_SetColor(GUI_BLACK);
		GUI_SetTextMode(GUI_TM_TRANS);
		GUI_DispStringAt(pBuffer, pDrawItemInfo->x0 + 20 + pInfoCur.Level * 15, pDrawItemInfo->y0);
		break;
	case WIDGET_ITEM_DRAW_BITMAP:
		// Calc the Index to get the item handler from the list. Divide y0 by the item height.
		Index = pDrawItemInfo->y0 / 32;

		TREEVIEW_GetUserData(pDrawItemInfo->hWin, &UserData, 1);

		switch (UserData) {
		case 2:
			// Do nothing, just change it to 3
			UserData = 3;
			TREEVIEW_SetUserData(pDrawItemInfo->hWin, &UserData, 1);
			break;
		case 3:
			// Previous item was selected so correct item index calculation for new coords
			Index = (pDrawItemInfo->y0 - 32) / 32;
			UserData = 0;
			TREEVIEW_SetUserData(pDrawItemInfo->hWin, &UserData, 1);
			break;
		}

		// Get item info in the treeview
		TREEVIEW_ITEM_GetInfo(phItem[Index], &pInfoCur);

		// If item is node draw bigger plus and minus bitmaps instead of default bitmaps
		if (pInfoCur.IsNode) {
			if (pInfoCur.IsExpanded)
				GUI_DrawBitmap(&bmImg_minus, 4, pDrawItemInfo->y0 + 8);
			else
				GUI_DrawBitmap(&bmImg_plus, 4, pDrawItemInfo->y0 + 8);
		}
		break;
	default:
		return TREEVIEW_OwnerDraw(pDrawItemInfo);
		break;
	}
	return 0;
}
// USER END

/*********************************************************************
*
*       _cbDialog
*/
static void _cbDialog(WM_MESSAGE * pMsg) {
  TREEVIEW_ITEM_Handle   hTreeItemCur;
  TREEVIEW_ITEM_Handle   hTreeItemNew;
  WM_HWIN                hItem;
  int                    NCode;
  int                    Id;
  // USER START (Optionally insert additional variables)
  int NumItems;
  U8 UserData;
  // USER END

  switch (pMsg->MsgId) {
  case WM_INIT_DIALOG:
    //
    // Initialization of 'Window_CustomTreeview'
    //
    hItem = pMsg->hWin;
    WINDOW_SetBkColor(hItem, GUI_MAKE_COLOR(0x00F5D092));
    //
    // Initialization of 'Treeview'
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TREEVIEW_0);
    hTreeItemCur = TREEVIEW_GetItem(hItem, 0, TREEVIEW_GET_LAST);
    hTreeItemNew = TREEVIEW_ITEM_Create(TREEVIEW_ITEM_TYPE_NODE, "Node1", 0);
    TREEVIEW_AttachItem(hItem, hTreeItemNew, hTreeItemCur, TREEVIEW_INSERT_BELOW);
    // USER START (Optionally insert additional code for further widget initialization)
	NumItems = 0;

	// Add "Node 1" hanlder to the list
	phItem[NumItems++] = hTreeItemNew;

	// Get the handler of the TREEVIEW widget
	hTreeview = WM_GetDialogItem(pMsg->hWin, ID_TREEVIEW_0);

	// Set a bigger font 
	TREEVIEW_SetFont(hTreeview, GUI_FONT_32_ASCII);

	// Create another two child items and add the handlers to the list
	hTreeItemCur = hTreeItemNew;
	hTreeItemNew = TREEVIEW_ITEM_Create(TREEVIEW_ITEM_TYPE_LEAF, "Leaf10", 0);
	TREEVIEW_AttachItem(hTreeview, hTreeItemNew, hTreeItemCur, TREEVIEW_INSERT_FIRST_CHILD);

	phItem[NumItems++] = hTreeItemNew;

	hTreeItemCur = hTreeItemNew;
	hTreeItemNew = TREEVIEW_ITEM_Create(TREEVIEW_ITEM_TYPE_LEAF, "Leaf11", 0);
	TREEVIEW_AttachItem(hTreeview, hTreeItemNew, hTreeItemCur, TREEVIEW_INSERT_BELOW);
	
	phItem[NumItems++] = hTreeItemNew;

	// Set text indentation to 0
	TREEVIEW_SetTextIndent(hTreeview, 0);

	// Turn off the lines
	TREEVIEW_SetHasLines(hTreeview, 0);

	// Set custom drawing function
	TREEVIEW_SetOwnerDraw(hTreeview, _OwnerDraw_TREEVIEW);

	// UserData = 0 at first
	UserData = 0;
	TREEVIEW_SetUserData(hTreeview, &UserData, 1);

	// Set callback for TREEVIEW widget
	WM_SetCallback(hTreeview, _cbTreeview);
    // USER END
    break;
  case WM_NOTIFY_PARENT:
    Id    = WM_GetId(pMsg->hWinSrc);
    NCode = pMsg->Data.v;
    switch(Id) {
    case ID_TREEVIEW_0: // Notifications sent by 'Treeview'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_MOVED_OUT:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_SEL_CHANGED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    // USER START (Optionally insert additional code for further Ids)
    // USER END
    }
    break;
  // USER START (Optionally insert additional message handling)
  // USER END
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       CreateWindow_CustomTreeview
*/
WM_HWIN CreateWindow_CustomTreeview(void);
WM_HWIN CreateWindow_CustomTreeview(void) {
  WM_HWIN hWin;

  hWin = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbDialog, WM_HBKWIN, 0, 0);
  return hWin;
}

// USER START (Optionally insert additional public code)
// USER END

/*************************** End of file ****************************/
